
var app = new Vue({
  el: '#app',
  template: "#main",
  data: function () {
    return {
      assignment: [],
      numberMin: 0,
      numberMax: 20,
      count: 5,
      isChecked: false,
      numTruthy: 0,
      numFalsy: 0,
      findingMin: "Y",
      num: 5,
   
    }
  },
  methods: {
    createAssignment(_count, _num){
      var i, j, len = _count, num = _num;
      var obj = {};

      this.assignment = [];

      for (i = 0; i < len; i++){
        obj = {
          arr: [],
          user: null,
          solution: null
        };

        for (j = 0; j < num; j++){
          obj.arr[j] = this.getRandomInt(1 * this.numberMin, 1 * this.numberMax);
        };

        if (this.findingMin == 'Y') {
          obj.solution = this.findMin(obj.arr);
        }
        else {
          obj.solution = this.findMax(obj.arr);
        };

        this.assignment.push(obj);
      };

    },
    getRandomInt: function(min, max){
      return Math.floor(Math.random() * (max - min + 1)) + min;
    },
    checkSolutions: function(){
      var example;
      this.isChecked = true;
      this.numTruthy = this.numFalsy = 0;

      for (var i = 0; i < this.count; i++){
        console.log("i = ", i);
        example = this.assignment[i];

        if (example.user != null) console.log("user idx: ", example.user);
        if (example.user != null) console.log("user num: ", example.arr[example.user]);
        console.log("solution: ", example.solution);
        

        if ((example.user != null) && (example.arr[example.user] == example.solution)){
          this.numTruthy++;
          console.log("Yes: ", i);
        };
        if ((example.user != null) && (example.arr[example.user] != example.solution)){
          this.numFalsy++;
          console.log("No: ", i);
        };
        console.log("====================");
      }
    },
    newAssignment: function(){
      this.isChecked = false;
      this.numTruthy = 0;
      this.numFalsy = 0;
      this.createAssignment(this.count, this.num);
    },
    setCount(_count){
      this.count = _count;
    },
    setNumberMin: function(_min){
      this.numberMin = _min;
    },
    setNumberMax: function(_max){
      this.numberMax = _max;
    },
    setNum: function(_num){
      this.num = _num;
    },
    findMin: function(_arr){
      var i, min = _arr[0], len = _arr.length;

      for (i = 1; i < len; i++){
        if (_arr[i] < min){
          min = _arr[i];
        }
      };
      return min;
    },
    findMax: function(_arr){
      var i, max = _arr[0], len = _arr.length;

      for (i = 1; i < len; i++){
        if (_arr[i] > max){
          max = _arr[i];
        }
      };
      return max;
    }  ,
    select: function(_idx, _index){
      this.assignment[_idx].user = _index;
    },
    clearAll: function(){
      this.assignment = [];
      this.isChecked = false;
    }
  },
  computed: {

  },
  created: function(){

  },
  mounted: function(){

  },
  components: {

  },
  watch: {
    findingMin: function(val){
      this.clearAll();
    }
  }
});
